<template>

    <div id="login" class="container col-6 col-md-4" @keydown="clear">
        <div class="form-group">
            <label for="username">Username</label>
            <input type="text" class="form-control" id="username" value="" v-model="form.username">
            <div class="alert alert-danger" v-if="form.errors.has('username')"
                 v-text="form.errors.get('username')"></div>
        </div>
        <div class="form-group">
            <label for="password">Password</label>
            <input type="password" class="form-control" id="password" value="" v-model="form.password">
            <div class="alert alert-danger" v-if="form.errors.has('password')"
                 v-text="form.errors.get('password')"></div>
        </div>
        <button type="submit" class="btn btn-primary" :disabled="form.errors.any()" @click="submit">Submit</button>

    </div>
</template>

<script>
    import Form from 'form-backend-validation';
    import {mapActions} from 'vuex'
    import {mapState} from 'vuex'


    export default {
        data() {
            return {
                form: new Form({
                    username: '',
                    password: '',
                }, {
                    resetOnSuccess: false,
                    http: this.$http,
                }),
            }
        },
        computed: mapState([
            // map this.count to store.state.count
            'auth'
        ]),
        methods: {

            clear() {
                this.form.errors.clear()
            },
            submit() {
                this.$store.dispatch('login', this.form).then(response => this.onSuccess(response)).catch(response => this.onError(response));
            },

            onSuccess(response) {
                this.$store.dispatch('setAuthUser', response)
                this.$router.push('/')
                // if (this.auth.role === 'admin') {
                //     this.$router.push('/admin')
                // } else {
                //     this.$router.push('/')
                // }
            },
            onError(response) {
                console.log(response)
                console.log(this.form.errors.all())
            }
        },
        name: "Login",
    }
</script>

<style scoped>

</style>
